#include "common.h"
#include "simulation.h"

net* motherNet;

simulation* Node::SimObj;

bool Node::exec(int time, int , Pin*){

    if(!requestRun){
      requestRun = true;
      SimObj->scheduleEvent(new deliverEvent(time+1,this));
    }
    return( false );
}

bool And::exec(int time,int svalue, Pin* pin){

    pin->EIN = svalue;  // Pin ̒lZbg
    out =1;

    // SẴsɑ΂
    pinMap::iterator pitr;        // SĂ Pin XL邽߂̃Ce[^
    for ( pitr  = inPin.begin(); pitr != inPin.end(); pitr++ ){
      if(pitr->second->EIN ==2 ){  // ͂ 2 ł,
	out = 2;
	break;                     // for 𔲂o
      }else if(pitr->second->EIN ==0 ){  // ͂ 0 ł,
	out = 0;
	break;                     // for 𔲂o
      }
    }

    return( Node::exec( time, svalue, pin ) ); // NX exec Ăт
}

bool Or::exec(int time,int svalue, Pin* pin){

    pin->EIN = svalue;
    out =0;

    // SẴsɑ΂
    pinMap::iterator pitr;        // SĂ Pin XL邽߂̃Ce[^
    for ( pitr  = inPin.begin(); pitr != inPin.end(); pitr++ ){
      if(pitr->second->EIN ==2 ){  // ͂ 2 ł,
	out = 2;
	break;                     // for 𔲂o
      }else if(pitr->second->EIN ==1 ){  // ͂ 1 ł,
	out = 1;
	break;                     // for 𔲂o
      }
    }
    
    return( Node::exec( time, svalue, pin ) ); //NX exec Ăт
}


bool Not::exec(int time,int svalue, Pin* pin){
  pin->EIN = svalue;

  if(svalue != 2){
     out = svalue  ?  0 : 1;
  }

  return( Node::exec( time, svalue, pin ) ); // NX exec Ăт
}

bool NullNode::exec(int time,int svalue, Pin* pin){
  pin->EIN = svalue;
  out = svalue;	

  return( Node::exec( time, svalue, pin ) ); // NX exec Ăт
}
